#include "FXPaneHeader.h"

FXDEFMAP(FXPaneHeader) FXPaneHeaderMap[]={
  FXMAPFUNC(SEL_COMMAND,FXWindow::ID_SETSTRINGVALUE,FXPaneHeader::onCmdSetStringValue),
  FXMAPFUNC(SEL_COMMAND,FXWindow::ID_GETSTRINGVALUE,FXPaneHeader::onCmdGetStringValue),
  };
FXIMPLEMENT(FXPaneHeader,FXHorizontalFrame,FXPaneHeaderMap,ARRAYNUMBER(FXPaneHeaderMap))

// Deserialisation
FXPaneHeader::FXPaneHeader(){
  flags|=FLAG_ENABLED;
  }

// Make new pane header
FXPaneHeader::FXPaneHeader(FXComposite* p, const FXString& lbl, FXIcon* icon=NULL, FXObject* tgt=NULL, FXSelector sel, FXuint opts,
                           FXint x, FXint y, FXint w, FXint h, FXint pl, FXint pr, FXint pt, FXint pb)
    : FXHorizontalFrame(p, opts|LAYOUT_FILL_X, x, y, w, h, pl, pr, pt, pb, 0, 0){
  FXString buttonText = "\tClose\tClose this pane.";
  if ( icon == NULL ) buttonText = " X " + buttonText;
  textLabel = new FXLabel ( this, lbl, NULL, LAYOUT_CENTER_Y|JUSTIFY_LEFT, 0,0,0,0, 0,0,0,0 );
  closeButton = new FXButton ( this, buttonText, icon, tgt, sel, LAYOUT_CENTER_Y|BUTTON_TOOLBAR|FRAME_RAISED|LAYOUT_RIGHT, 0,0,0,0, 0,0,0,0 );
  }

FXPaneHeader::~FXPaneHeader(){
  delete closeButton;
  delete textLabel;
  }

// Change the label text
void FXPaneHeader::setText(const FXString& lbl){
  textLabel->setText(lbl);
  }

// Get the label text
FXString FXPaneHeader::getText() const {
  return textLabel->getText();
  }

// Save data
void FXPaneHeader::save(FXStream& store) const {
  FXHorizontalFrame::save(store);
  store << textLabel;
  store << closeButton;
  }

// Load data
void FXPaneHeader::load(FXStream& store){
  FXHorizontalFrame::load(store);
  store >> textLabel;
  store >> closeButton;
  }

// Update value from a message
long FXPaneHeader::onCmdSetStringValue(FXObject*,FXSelector,void* ptr){
  setText(*((FXString*)ptr));
  return 1;
  }

// Obtain value from text field
long FXPaneHeader::onCmdGetStringValue(FXObject*,FXSelector,void* ptr){
  *((FXString*)ptr)=getText();
  return 1;
  }
